package getOptLong;

public class ArgumentOption extends Option{
	public ArgumentOption(String longOption, String shortOption,
		   String argDescription, String description, ArgRun delegate) {
		this(longOption, shortOption, argDescription, description, delegate, false);
	}

	public ArgumentOption(String longOption, String shortOption,
			   String argDescription, String description, ArgRun delegate, boolean required) {
			super(longOption, shortOption, argDescription, description, required);
			this.delegate = delegate;
		}	
	
	ArgRun delegate;

	@Override
	public int parse(String[] argv, int counter) {
		try {
			if(!match(argv[counter])) return 0;
			if(delegate.run(argv[counter+1])){
				satisfied = true;
				return 2;
			} else {
				System.out.println("["+argv[counter]+"] - error parsing argument: "+argv[counter+1]);
				return 0;
			}
		} catch (IgnoreOptionException e) {
			return 2;
		}
	}
}
