package getOptLong;

import java.util.Formatter;
import java.util.LinkedList;
import java.util.List;

//import getOptLong.Option;

public class GetOptLong {
	public List<String> getNonOptions() {
		return nonOptions;
	}
	private String program_name = "TetaSARTS";
	
	public void printHelp() {
		this.helpPrinter.delegate.run();
	}

	BooleanOption helpPrinter = new BooleanOption("--help", "-h", "Display this help.", new BoolRun() {
		final int WIDTH = 120; 
		public void run() {
			int shortOptionLength 	= 0;
			int longOptionLength 	= 0;
			int argLOptionLength 	= 0;
			int boolLOptionLength 	= 0;
			int argDescLength 		= 0;
			for(Option option : options){ // find the max-length of the sections before description
				if(option.argDesc == null && boolLOptionLength < option.longOption.length()){
					boolLOptionLength = option.longOption.length();
				} else if(option.argDesc != null){
					if(argLOptionLength < option.longOption.length())
						argLOptionLength = option.longOption.length();
					
					if(argDescLength < option.argDesc.length())
						argDescLength = option.argDesc.length();
				}
				
//				longOptionLength = longOptionLength>option.longOption.length()?longOptionLength:option.longOption.length();
				shortOptionLength = shortOptionLength>option.shortOption.length()?shortOptionLength:option.shortOption.length();
			}
			
			int boolPad = Math.max(argLOptionLength+argDescLength, boolLOptionLength)+4;
			longOptionLength = boolPad;
			int argPad  = argLOptionLength;
			int aDesPad = argDescLength+2;
			
			System.out.println();
			System.out.println();
			System.out.println(" **** " + program_name + " **** ");
			System.out.println("Usage:" + program_name + " [OPTIONS] [CLASSFILES]");
			System.out.println("Use '%' prefix to ignore options: %-h or %--help will not print help.");
			System.out.println();
			for(Option option : options){
				StringBuilder optionStringBuilder = new StringBuilder();
				Formatter f = new Formatter(optionStringBuilder);
//				f.format("%3$3s%1$-"+(longOptionLength+4)+"s%2$-3s%3$3s:%3$3s", option.longOption, option.shortOption, "");
				int preColon = 1;
				int postColon = 1;
				if(option.argDesc == null){
					f.format(" %2$-"+(shortOptionLength+1)+"s%1$-"+(boolPad)+"s"+
							 "%3$"+preColon+"s:"+
							 "%3$"+postColon+"s",
							 option.longOption, option.shortOption, "");
				}
				else {
					f.format(" %2$-"+(shortOptionLength+1)+"s%1$-"+(argPad)+"s"+
							 " %4$-"+aDesPad+"s "+
							 "%3$"+preColon+"s:"+
							 "%3$"+postColon+"s", 
							 option.longOption, option.shortOption, "", "<"+option.argDesc+">");
				}			
				
				String first = optionStringBuilder.toString();
				// split into parts
				int l = 0;
				int descriptionSize = WIDTH - first.length(); 
				boolean first_time = true;
				while(l < option.description.length()){
					int stop = l+descriptionSize;
					if(descriptionSize+l > option.description.length()){
						stop = option.description.length();
					}
					String substring = option.description.substring(l, stop);
					if(option.description.length() - l > substring.length()){
						int stringEnd = substring.lastIndexOf(" ");
//						String validString = substring.substring(0, stringEnd);
						if(stringEnd==-1) 
							stringEnd = substring.length();
						else if(substring.substring(0, stringEnd).contains("\n")){
							stringEnd = substring.substring(0, stringEnd).lastIndexOf("\n")+1;
						}

						String validString = substring.substring(0, stringEnd);
						l+= validString.length();
//						f.format("%1$"+(first_time?descriptionSize:WIDTH)+"s%n", validString);
						f.format("%1$"+(first_time?1:(WIDTH-descriptionSize))+"s  %2$-1s %n", " ",validString.replace("\n", ""));
						first_time=false;
					} else {
						f.format("%1$"+(first_time?1:(WIDTH-descriptionSize))+"s  %2$-1s %n", "", substring);
						l+= substring.length();
					}
				}
//				f.format("%n");
				System.out.print(optionStringBuilder.toString());
				System.out.println();
				f.close();
			}
			System.exit(0);
		}
	});
	
	List<Option> options = null;
	
	public GetOptLong(String[] argv, final List<Option> options) {
		int counter=0;
		for(Option o:options){
			if("-h".equals(o.shortOption) || "--help".equals(o.longOption)){
				System.err.println("help option is reserved!");
			}
		}		
		/// add help option
		options.add(helpPrinter);
		this.options = options;
		
		
		while(counter<argv.length){
			int oldcounter = counter;
			for (Option option : options){
				counter+=option.parse(argv, counter);
//				System.out.println("counter/length: "+counter+"/"+argv.length);
				if(counter > oldcounter) break;
			}
			if (oldcounter == counter && (argv[counter].startsWith("-") || argv[counter].startsWith("--")) ){
				System.out.println("error parsing argument: "+argv[counter]);
				break;
			} else if (oldcounter == counter) {
				if(! argv[counter].startsWith("%"))
					nonOptions.add(argv[counter]);
				counter++;
			}
		}
		for(Option option : options){
			if(!option.satisfied){
				System.out.println("Error, "+option.longOption+" missing...");
				
				System.exit(0);
			}
			
		}

	}
	List<String> nonOptions = new LinkedList<String>();	
	
}
