package getOptLong;

public abstract class Option {
	public String longOption;
	public String shortOption;
	public String description;
	public String argDesc;
	public boolean satisfied = true;
	
	
	
	public Option(String longOption, String shortOption, String description, boolean required) {
		this.longOption = longOption;
		this.shortOption = (shortOption);
		this.description = description;
		this.satisfied = !required;
	}
	
	public Option(String longOption, String shortOption, String description) {
		this.longOption = longOption;
		this.shortOption = (shortOption);
		this.description = description;
	}

	public Option(String longOption, String shortOption, String argumentDesc, String description){
		this(longOption, shortOption, description);
		this.argDesc = argumentDesc;
	}
	
	public Option(String longOption, String shortOption, String argumentDesc, String description, boolean required){
		this(longOption, shortOption, description, required);
		this.argDesc = argumentDesc;
	}

	public boolean match(String arg) throws IgnoreOptionException{
//		System.out.println("testing "+ arg + " in:\n -"+ 
//				shortOption +": " + arg.equals("-"+shortOption) +
//				"\n --"+longOption +": " + arg.equals("--"+longOption) );
		if(arg.equals("%"+longOption) || arg.equals("%"+shortOption)){
			System.out.println("Ignoring option: "+ this.toString());
			throw new IgnoreOptionException();
		}
		return (arg.equals(longOption) || arg.equals(shortOption));
	}	
	
	public String toString()
	{
		return longOption +" "+shortOption+ " --- " + description;
	}
	
	public abstract int parse(String[] argv, int counter);
}
