package org.testapp;

import org.testapp.classes.IBase;
import org.testapp.classes.Base;
import org.testapp.classes.ExtendedBase;
import org.testapp.classes.SuperExtendedBase;

public class Inheritance {

	/**
	 * Should call Base.workon(int)
	 */
	public void invokeInheritedMethod() {
		
		ExtendedBase instance = new ExtendedBase();
		
		instance.workon(1);
		
	}
	
	/**
	 * Should call SuperExtendedBase.compute(int)
	 */
	public void invokeOverwrittenMethod() {
		
		SuperExtendedBase instance = new SuperExtendedBase();
		
		instance.compute(2);
		
	}
	
	/**
	 * Should call both SuperExtendedBase.compute(int) and Base.compute(int)
	 */
	public void invokePolymorphism() {
		
		Base instance = (Base) new SuperExtendedBase();
		
		instance.compute(2);
		
	}
	
	/**
	 * Should call both SuperExtendedBase.compute(int) and Base.compute(int)
	 */
	public void invokeInterfaceMethod() {
		
		IBase instance = new SuperExtendedBase();
		
		instance.compute(23);
		
	}
	
	/**
	 * Should call both methods in sequence
	 */
	public void invokeMethodCallingSuper() {
		
		ExtendedBase instance = new ExtendedBase();
		
		instance.passdown();
		
	}
	
	
}