package com.tetaj.cfggenerators.jophelper;

import java.util.HashMap;


import com.jopdesign.libgraph.cfg.ControlFlowGraph;
import com.jopdesign.libgraph.cfg.GraphException;
import com.jopdesign.libgraph.struct.MethodInfo;
import com.jopdesign.libgraph.struct.TypeException;
import com.tetaj.cfggenerators.jophelper.jopircfg.IRCFG;

public class CFGGenerator {
	
	private String fqMethodName;
	private String classPath;
	HashMap<String, ControlFlowGraph> cfgMap;

	public CFGGenerator(String fqMethodName, String classPath) throws GraphException, TypeException{
		this.fqMethodName = fqMethodName;
		this.classPath = classPath;
		this.cfgMap = new HashMap<String, ControlFlowGraph>();
		this.buildRecursiveGraphs(this.fqMethodName);
	}
	
	public HashMap<String, ControlFlowGraph> getCfgMap() throws GraphException, TypeException{
		return this.cfgMap;
	}
	public String getFqMethodName() {
		return fqMethodName;
	}
	
	private void buildRecursiveGraphs(String fqMethodName) throws GraphException, TypeException {
		IRCFG ircfg = new IRCFG(fqMethodName, this.classPath);
		
		if (ircfg.getCFG()!=null)
			cfgMap.put(fqMethodName, ircfg.getCFG());
		else
			System.out.println("Method: "+fqMethodName + " did not generate a CFG."); //TODO Only for debug purpose
		
		for (MethodInfo methodInfo : ircfg.getInvokedMethodInfos()) {
			System.out.println("MethodInfo: "+methodInfo.getFQMethodName());
			if(!cfgMap.containsKey(methodInfo.getFQMethodName())){
				buildRecursiveGraphs(methodInfo.getFQMethodName());
			}
		}
	}
}
