package com.tetaj.modelgenerator.cfganalysis;

import java.util.HashMap;
import java.util.LinkedList;

import com.tetaj.ircfg.ControlFlowGraph;

public class CfgAnalysis {

	LinkedList<IAnalysis> analysisList = new LinkedList<IAnalysis>();
	
	HashMap<String, ControlFlowGraph> cfgTable;
	
	public CfgAnalysis(HashMap<String, ControlFlowGraph> CFGtable) {
		this.cfgTable = CFGtable;
		
		/*
		 * Add all the great CFG analyses here :)
		 */
		analysisList.add(new LoopBoundAnalysis(this.cfgTable));
		analysisList.add(new CollapseIfConditionAnalysis(this.cfgTable));
		//analysisList.add(new ProgressMeasureAnalysis(this.cfgTable));
	}
	
	public void conductCfgAnalyses() throws CfgAnalysisException {
		for(IAnalysis cfgAnalysis : analysisList) {
			cfgAnalysis.conductAnalysis();
		}
	}
}
