package com.tetaj.modelgenerator.annotationextractor.file;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;

import org.junit.After;
import org.junit.Assert;
import org.junit.Test;

import com.tetaj.prettyprinter.AppConfig;

import com.tetaj.modelgenerator.annotationextractor.file.FileFinder;

public class FileFinderTest {

	@After
    public void tearDown() {
		ArrayList<String> sourcePaths = AppConfig.getSourcePaths();
		sourcePaths.clear();
    }
	
	@Test
	public void testGetFileReader() throws IOException {
		ArrayList<String> sourcePaths = AppConfig.getSourcePaths();
		sourcePaths.add("./resources/testappsrc/");
		
		FileFinder fileFinder = new FileFinder();
		fileFinder.find("org/testapp/AnnotationTestClass.java");
	}
	
	@Test
	public void testGetFileReaderMissingSlash() throws IOException {
		ArrayList<String> sourcePaths = AppConfig.getSourcePaths();
		sourcePaths.add("./resources/testappsrc");
		
		FileFinder fileFinder = new FileFinder();
		fileFinder.find("org/testapp/AnnotationTestClass.java");
	}
	
	@Test
	public void testCachedFile() throws IOException {
		ArrayList<String> sourcePaths = AppConfig.getSourcePaths();
		sourcePaths.add("./resources/testappsrc/");
		
		FileFinder fileFinder = new FileFinder();
		
		BufferedReader file1 = fileFinder.find("org/testapp/AnnotationTestClass.java");
		BufferedReader file2 = fileFinder.find("org/testapp/AnnotationTestClass.java");
		BufferedReader file3 = fileFinder.find("org/testapp/ControlStructures.java");
		
		Assert.assertSame(file1, file2);
		Assert.assertNotSame(file2, file3);
	}

}
