package com.tetaj.modelgenerator.ircfg;

import static org.junit.Assert.assertEquals;

import java.util.List;

import org.junit.Test;

import com.tetaj.ircfg.BasicBlock;
import com.tetaj.ircfg.ControlFlowGraph;
import com.tetaj.ircfg.ControlFlowGraphException;

public class ControlFlowGraphTest {
	
	@Test 
	public void testControlFlowGraph() throws ControlFlowGraphException {
		BasicBlock entry = new BasicBlock(0);
		BasicBlock bb1 = new BasicBlock(1);
		BasicBlock bb2 = new BasicBlock(2);
		BasicBlock bb3 = new BasicBlock(3);
		BasicBlock bb4 = new BasicBlock(4);
		BasicBlock bb5 = new BasicBlock(5);
		BasicBlock bb6 = new BasicBlock(6);
		
		entry.setFallthrough(bb1);
		bb1.addBranch(bb2);
		bb1.addBranch(bb3);
		bb1.setFallthrough(bb4);
		bb2.addBranch(entry);
		bb3.addBranch(bb4);
		bb3.setFallthrough(bb5);
		bb4.addBranch(bb5);
		bb4.setFallthrough(bb6);
		
		ControlFlowGraph cfg = new ControlFlowGraph("", "");
		cfg.addBasicBlock(entry);
		cfg.addBasicBlock(bb1);
		cfg.addBasicBlock(bb2);
		cfg.addBasicBlock(bb3);
		cfg.addBasicBlock(bb4);
		cfg.addBasicBlock(bb5);
		cfg.addBasicBlock(bb6);
		
		
		List<BasicBlock> bbs = cfg.getSortedBasicBlockList();
		
		for(int i = 0; i< bbs.size(); i++)
			assertEquals(i, bbs.get(i).getId());
		
		assertEquals(bb4, cfg.getBasicBlock(4));
		
	}


	
}
