package com.tetaj.modelgenerator.staticmodels;

import java.io.IOException;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.jdom.JDOMException;
import org.junit.Test;

import com.jopdesign.wcet.uppaal.model.DuplicateKeyException;
import com.jopdesign.wcet.uppaal.model.NTASystem;
import com.jopdesign.wcet.uppaal.model.XmlSerializationException;
import com.tetaj.uppaallayouter.UppaalLayouter;

public class StaticModelsTest {

	@Test
	public void testMetamocAvrModel() throws DuplicateKeyException, IOException, JDOMException, InterruptedException, XmlSerializationException, TransformerException{
		NTASystem system = StaticModels.getMetamocAVRModel("Assembly");
		
		org.w3c.dom.Document doc = system.toXML();
		
		UppaalLayouter layouter = new UppaalLayouter(doc);
		doc = layouter.getLayoutedXmlW3Document();
		
		 TransformerFactory tranFactory = TransformerFactory.newInstance();
	     Transformer aTransformer = tranFactory.newTransformer();
	
	     Source src = new DOMSource(doc);
	     System.out.println("Starting the XML file creation");
	  
	     Result dest = new StreamResult("metamocAvr.xml");
	     aTransformer.transform(src, dest);
		
		
	}
}
