package tetasarts;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;

import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.util.ClassPath;
import org.apache.bcel.util.ClassPath.ClassFile;

public final class Options {
	
	public static enum DevirtualizationType {
		NAIVE,
		CHA,
		RTA,
		VTA,
		RTAVTA
	}
	public static boolean CHECK_DUPLICATE_CLASSES_IN_CLASSPATH = false;
	/*
	 * Default devirtualization method is NAIVE - look at the static, declared type and consider all subclasses
	 */
	public static DevirtualizationType DEVIRTUALIZATION_METHOD = DevirtualizationType.NAIVE;
	
	
	
	public static enum SchedulerType {
		FPS,
		FIFO,
		EDF
	}
	/*
	 * Default scheduler is FPS
	 */
	public static SchedulerType SCHEDULER_TYPE = SchedulerType.FPS;
	
	public static enum PlatformType {
		JOP,
		HVMAVR
	}
	/*
	 * Default platform is JOP
	 */
	public static PlatformType PLATFORM_TYPE = PlatformType.JOP;
	
	/*
	 * TODO: consider making a type that encapsulates all info related to the underlying hardware!
	 */
	//The clock frequency is by default set to the default clock frequency of the JOP
	public static int MHZ = 60;
	
	public static enum ScjApi {
		SCJ,
		SCJ2
	}
	public static ScjApi SCJ_API = ScjApi.SCJ2;
	
	public static boolean EXPLICIT_MODEL = false;
	public static boolean GENERATE_WCRT = false;
	public static boolean GENERATE_BLOCKING = false;
	public static boolean GENERATE_WCET = false;
	
	public static String MAIN_ENTRY_POINT = "main";
	public static boolean LAZY_METHODS = false;
	public static boolean LAY_TEMPLATES_NICELY = false;
	public static boolean CONSIDER_FINALIZERS = false;
	public static boolean USE_JOP_OPCODE_METHODS = false;
	public static boolean COLLAPSE_BASIC_BLOCKS = true;
	public static boolean REPORT_MISSING_WCET = false;
	public static ClassPath classpath = new ClassPath("");
	public static String outputDir = "";
	public static String outputFile = "output.xml";
	public static boolean UTILIZATION_MONITOR = false;
	public static String LAYOUT_UPPAAL = System.getProperty("user.home")+"/pyuppaal/"; //"~/pyuppaal/";
	public static boolean COUNT_NEWS = false;
	public static String NEW_COUNTER_ID = "liveObjects";
	public static boolean FULL_CLASS_LOADING = false;
	public static boolean PRECISE_LOOP = false;
	public static boolean STATISTICAL_MODEL_CHECKING = false;
	
	

	public static boolean WARN_ATHROW = false;
	
	public static boolean ANALYSE_JAVA_CLASS_LIB = false;




}
