package tetasarts;

import java.io.IOException;

import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.ClassFormatException;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.util.ClassPath.ClassFile;

import tetasarts.generator.Constants;
import tetasarts.generator.JavaTranslator;

public class Tester {
	class A{
		public void method(){};
		
		@Override
		protected void finalize() throws Throwable {
			// TODO Auto-generated method stub
			System.out.println("A");
			super.finalize();
		}
	}
	
	class B extends A{
		@Override
		protected void finalize() throws Throwable {
			// TODO Auto-generated method stub
			System.out.println("B");
		}

		@Override
		public void method() {
			super.method();
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
//		for(int i= 0;i<1000000;i++)
//			new Tester().new B();
		
//		JavaTranslator t = new JavaTranslator("");
		try {
			JavaClass jc = new ClassParser("/tmp/B.class").parse();
			System.out.println(jc.getSuperClass());
			
			for(Method m : jc.getMethods()){
				System.out.println(m.getName());
				System.out.println("Abstract   : "+m.isAbstract());
				System.out.println("Native     : "+m.isNative());
				System.out.println("Synthetic  : "+m.isSynthetic());
				System.out.println("Static     : "+m.isStatic());
				if(m.getName().equals("method")){
					System.out.println(m.getCode().toString());
				}
				if(m.getName().equals("finalize")){
					System.out.println(m.getCode().toString());
					for(Attribute a: m.getAttributes()){
						System.out.println("fisk: "+a);
					}
				}
				if(m.getName().equals("toString")){
					System.out.println(m.getCode().toString());
				}
				
			}
			
		} catch (ClassFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//		ClassFile classFile = Constants.classpath.getClassFile("");
		catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
