package tetasarts.generator;

import java.util.HashMap;

import java.util.Map;
import org.apache.bcel.util.ClassPath;

public class Constants {
	public final static boolean INVOKEINTERFACEDEBUG = false;
	
	public static String RUN_METHOD_SIGNATURE = "()Z";
	
	public static String SCJ_PACKAGE = "javax.scj";
	
	public static String SPORADIC_THREAD = "javax.scj.SporadicThread";
	public static String PERIODIC_THREAD = "javax.scj.PeriodicThread";
	
	public static String PERIODIC_PARAMETERS = "javax.scj.PeriodicParameters";
	public static String SPORADIC_PARAMETERS = "javax.scj.SporadicParameters";
	
	public static String RELATIVETIME = "javax.scj.RelativeTime";
	public static String RELATIVETIMEMICRO = "javax.scj.RelativeTimeMicro";
	public static String RELATIVETIMEMILLI = "javax.scj.RelativeTimeMilli";
	public static String RELATIVETIMENANO = "javax.scj.RelativeTimeNano";
	public static String RELATIVETIMESECONDS = "javax.scj.RelativeTimeSeconds";
	
	public static String RT_THREAD_ADAPTER = "javax.scj.RtThreadAdapter";
	public static String RT_SW_THREAD_ADAPTER = "javax.scj.RtSwEventAdapter";
	public static String REALTIME_SYSTEM = "javax.scj.RealtimeSystem";
	public static String REALTIME_SYSTEM_FIRE = "RealtimeSystem.fire";

	public static String JOP_NATIVE = "com.jopdesign.sys.Native";
	public static String JOP_JVM_CLASS = "com.jopdesign.sys.JVM";
	
	public static String JAVA_LANG_OBJECT = "java.lang.Object";
	
	public static final boolean USE_TIME_PERIODIC_THREAD = false;
	
	public static final String EXPONENTIAL_RATE_STR = "EXPRATE";

	public static boolean USE_WCET = false;
	public static boolean DISABLE_TASKS = false;
	
	// JOP Native opcodes
	public static final short JOPSYS_RD = 209;
	public static final short JOPSYS_WR = 210;
	public static final short JOPSYS_RDMEM = 211;
	public static final short JOPSYS_WRMEM = 212;
	public static final short JOPSYS_RDINT = 213;
	public static final short JOPSYS_WRINT = 214;
	public static final short JOPSYS_GETSP = 215;
	public static final short JOPSYS_SETSP = 216;
	public static final short JOPSYS_GETVP = 217;
	public static final short JOPSYS_SETVP = 218;
	public static final short JOPSYS_INT2EXT = 219;
	public static final short JOPSYS_EXT2INT = 220;
	public static final short JOPSYS_NOP = 221;
	public static final short JOPSYS_INVOKE = 222;
	public static final short JOPSYS_COND_MOVE = 223;
	
	public static final Map<String, Short> NATIVE_METHOD_OPCODE = new HashMap<String, Short>();
	static {
		NATIVE_METHOD_OPCODE.put("rd", new Short(JOPSYS_RD));
		NATIVE_METHOD_OPCODE.put("wr", new Short(JOPSYS_WR));
		NATIVE_METHOD_OPCODE.put("rdMem", new Short(JOPSYS_RDMEM));
		NATIVE_METHOD_OPCODE.put("wrMem", new Short(JOPSYS_WRMEM));
		NATIVE_METHOD_OPCODE.put("rdIntMem", new Short(JOPSYS_RDINT));
		NATIVE_METHOD_OPCODE.put("wrIntMem", new Short(JOPSYS_WRINT));
		NATIVE_METHOD_OPCODE.put("getSP", new Short(JOPSYS_GETSP));
		NATIVE_METHOD_OPCODE.put("setSP", new Short(JOPSYS_SETSP));
		NATIVE_METHOD_OPCODE.put("getVP", new Short(JOPSYS_GETVP));
		NATIVE_METHOD_OPCODE.put("setVP", new Short(JOPSYS_SETVP));
		NATIVE_METHOD_OPCODE.put("int2extMem", new Short(JOPSYS_INT2EXT));
		NATIVE_METHOD_OPCODE.put("ext2intMem", new Short(JOPSYS_EXT2INT));
		NATIVE_METHOD_OPCODE.put("invoke", new Short(JOPSYS_INVOKE));
		NATIVE_METHOD_OPCODE.put("makeLong", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toInt", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toFloat", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toObject", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toIntArray", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toLong", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toInt", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("toDouble", new Short(JOPSYS_NOP));
		NATIVE_METHOD_OPCODE.put("memCopy", new Short(JOPSYS_NOP));
	}

	public static final Map<Short, String> NATIVE_OPCODE_METHOD = new HashMap<Short, String>();
	static {
		for(String key : NATIVE_METHOD_OPCODE.keySet()) {
			NATIVE_OPCODE_METHOD.put(NATIVE_METHOD_OPCODE.get(key), key);
		}
	}

	public static final Map<Short, String> NATIVE_OPCODE_NAME = new HashMap<Short, String>();

	static {
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_RD), "jopsys_rd");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_WR), "jopsys_wr");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_RDMEM), "jopsys_rdmem");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_WRMEM), "jopsys_wrmem");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_RDINT), "jopsys_rdint");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_WRINT), "jopsys_wrint");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_GETSP), "jopsys_getsp");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_SETSP), "jopsys_setsp");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_GETVP), "jopsys_getvp");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_SETVP), "jopsys_setvp");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_INT2EXT), "jopsys_int2ext");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_EXT2INT), "jopsys_ext2int");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_NOP), "jopsys_nop");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_INVOKE), "jopsys_invoke");
		NATIVE_OPCODE_NAME.put(new Short(JOPSYS_COND_MOVE), "jopsys_cond_move");
	}
	
	public static final Map<Short, String> JAVA_OPCODE_METHOD = new HashMap<Short, String>();
	static {
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FCONST_0, "f_fconst_0");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FCONST_1, "f_fconst_1");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FCONST_2, "f_fconst_2");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.AASTORE, "f_aastore");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LADD, "f_ladd");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FADD, "f_fadd");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LSUB, "f_lsub");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FSUB, "f_fsub");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LMUL, "f_lmul");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FMUL, "f_fmul");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.IDIV, "f_idiv");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LDIV, "f_ldiv");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FDIV, "f_fdiv");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.IREM, "f_irem");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LREM, "f_lrem");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FREM, "f_frem");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LNEG, "f_lneg");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FNEG, "f_fneg");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LSHL, "f_lshl");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LSHR, "f_lshr");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LUSHR, "f_lushr");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LAND, "f_land");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LOR, "f_lor");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LXOR, "f_lxor");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.I2L, "f_i2l");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.I2F, "f_i2f");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.F2I, "f_f2i");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.I2B, "f_i2b");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.I2S, "f_i2s");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LCMP, "f_lcmp");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FCMPL, "f_fcmpl");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.FCMPG, "f_fcmpg");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.TABLESWITCH, "f_tableswitch");   // not supported
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.LOOKUPSWITCH, "f_lookupswitch"); // not supported
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.NEW, "f_new");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.NEWARRAY, "f_newarray");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.ANEWARRAY, "f_anewarray");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.ATHROW, "f_athrow");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.CHECKCAST, "f_checkcast");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.INSTANCEOF, "f_instanceof");
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.MULTIANEWARRAY, "f_multianewarray");
		JAVA_OPCODE_METHOD.put((short)240, "f_resF0"); // sys_int
		JAVA_OPCODE_METHOD.put((short)241, "f_resF1"); // sys_exc
		JAVA_OPCODE_METHOD.put(org.apache.bcel.Constants.IMPDEP1, "f_sys_noim"); // sys_noimp
	}

	public static final Map<Short, String> JAVA_OPCODE_SIGNATURE = new HashMap<Short, String>();

	public static final boolean INLINE_WCET = true;
	static {
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FCONST_0, "()I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FCONST_1, "()I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FCONST_2, "()I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.AASTORE, "(III)V");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LADD, "(IIII)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FADD, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LSUB, "(JJ)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FSUB, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LMUL, "(JJ)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FMUL, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.IDIV, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LDIV, "(JJ)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FDIV, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.IREM, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LREM, "(JJ)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FREM, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LNEG, "(J)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FNEG, "(I)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LSHL, "(III)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LSHR, "(III)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LUSHR, "(III)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LAND, "(IIII)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LOR, "(IIII)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LXOR, "(IIII)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.I2L, "(I)J");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.I2F, "(I)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.F2I, "(I)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.I2B, "(I)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.I2S, "(I)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LCMP, "(JJ)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FCMPL, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.FCMPG, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.TABLESWITCH, "(I)V");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.LOOKUPSWITCH, "(I)V");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.NEW, "(I)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.NEWARRAY, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.ANEWARRAY, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.ATHROW, "(Ljava/lang/Throwable;)Ljava/lang/Throwable;");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.CHECKCAST, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.INSTANCEOF, "(II)I");
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.MULTIANEWARRAY, "()I");
		JAVA_OPCODE_SIGNATURE.put((short)240, "()V"); // sys_int
		JAVA_OPCODE_SIGNATURE.put((short)241, "()V"); // sys_exc
		JAVA_OPCODE_SIGNATURE.put(org.apache.bcel.Constants.IMPDEP1, "()V"); // sys_noimp
		new java.lang.Throwable();
	}
}
