package tetasarts.tir;

import tetasarts.exceptions.IncompatibleMergeException;

public abstract class Node<VisitorType extends INodeVisitor> implements INodeSubject<VisitorType>, Cloneable{
	private static int idcounter = 0;
	private int id = idcounter++;
	
	public int getID(){
		return id;
	}
	public void setID(int newId) {
		this.id = newId;
	}
	public abstract void accept(VisitorType v);	
	public Node<? extends VisitorType> merge(Node<VisitorType> other) throws IncompatibleMergeException{
		throw new IncompatibleMergeException("UNIMPLEMENTED");
	}
	public boolean canMerge(Node<VisitorType> other){
		return false;
	}
	public void informRemove(Graph<?, ?> graph){
	}
}
