package tetasarts.tir.basicblocks;

import java.util.*;
import org.apache.bcel.generic.InstructionHandle;

import tetasarts.tir.Node;

public abstract class AbstractBasicBlock extends Node<IBasicBlockVistitor>{
	private List<InstructionHandle> bytecodes = new LinkedList<InstructionHandle>();

	public List<InstructionHandle> getBytecodes() {
		return Collections.unmodifiableList(bytecodes);
	}
	
	public void addBytecode(InstructionHandle i) {
		bytecodes.add(i);
	}
	
	boolean target =false;
	public void setTarget(boolean target){
		this.target = target;
	}
	public boolean isTarget(){
		return target;
	}
	
	public abstract void accept(IBasicBlockVistitor v);
	
	public boolean isBranching(){
		return false;
	}
	
	private boolean synchronizedValue = false;
	public void setSynchronized(boolean value){
		synchronizedValue = value;
	}
	
	public boolean isSyncronized(){
		return synchronizedValue;
	}
	
	private int wcet = 0;
	public int getWCET(){
		return wcet;
	}
	
	public void setWCET(int wcet){
		this.wcet = wcet; 
	}
	String suffix = "";
	public void addSuffix(String suffix){
		this.suffix = suffix;
	}
	public String getName(){
		return this.getClass().getSimpleName().replaceAll("BasicBlock", "")+suffix;
	}
	
	@Override
	public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (obj == this)
            return true;
        if (obj.getClass() != getClass())
            return false;
		
        AbstractBasicBlock rhs = (AbstractBasicBlock) obj;
        
        if(rhs.getID() == this.getID())
        	return true;
        else
        	return false;
	}
}
