package tetasarts.tir.basicblocks;

import tetasarts.tir.basicblocks.basicBlockTypes.BranchingBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.EmptyBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.IfBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.LoopBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.MethodCallingBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.MonitorEnterBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.MonitorExitBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.NewBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.SimpleBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.SporadicInvokeBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.SwitchBasicBlock;

public abstract class AbstractBasicBlockVisitor implements IBasicBlockVistitor{

	@Override
	public void visitSwitchBasicBlock(SwitchBasicBlock switchBasicBlock) {
		defaultVisit(switchBasicBlock);
	}

	@Override
	public void visitSimpleBasicBlock(SimpleBasicBlock s) {
		defaultVisit(s);
	}

	@Override
	public void visitBranchingBasicBlock(BranchingBasicBlock s) {
		defaultVisit(s);
	}

	@Override
	public void visitMethodCallingBasicBlock(MethodCallingBasicBlock s) {
		defaultVisit(s);
	}
	
	@Override
	public void visitEmptyBasicBlock(EmptyBasicBlock s){
		defaultVisit(s);
	}
	
	@Override
	public void visitMonitorEnterBasicBlock(MonitorEnterBasicBlock s){
		defaultVisit(s);
	}
	
	@Override
	public void visitMonitorExitBasicBlock(MonitorExitBasicBlock s){
		defaultVisit(s);
	}
	
	@Override
	public void visitLoopBasicBlock(LoopBasicBlock s){
		defaultVisit(s);
	}
	
	@Override
	public void visitIfBasicBlock(IfBasicBlock s){
		defaultVisit(s);
	}
	
	@Override
	public void visitSporadicInvokeBasicBlock(
			SporadicInvokeBasicBlock sporadicInvokeBasicBlock) {
		defaultVisit(sporadicInvokeBasicBlock);	
	}
	
	@Override
	public void visitNewBasicBlock(NewBasicBlock newBasicBlock) {
		// TODO Auto-generated method stub
		defaultVisit(newBasicBlock);
	}
	
	public void defaultVisit(AbstractBasicBlock s){
		//TODO: Do something here?
	}
}
