package tetasarts.tir.basicblocks;

import tetasarts.tir.INodeVisitor;
import tetasarts.tir.basicblocks.basicBlockTypes.BranchingBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.EmptyBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.IfBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.LoopBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.MethodCallingBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.MonitorEnterBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.MonitorExitBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.NewBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.SimpleBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.SporadicInvokeBasicBlock;
import tetasarts.tir.basicblocks.basicBlockTypes.SwitchBasicBlock;

public interface IBasicBlockVistitor extends INodeVisitor{
	public void visitBranchingBasicBlock(BranchingBasicBlock s);
	public void visitSimpleBasicBlock(SimpleBasicBlock s);
	public void visitMethodCallingBasicBlock(MethodCallingBasicBlock s);
	public void visitEmptyBasicBlock(EmptyBasicBlock s);
	public void visitMonitorEnterBasicBlock(
			MonitorEnterBasicBlock monitorEnterBasicBlock);
	public void visitMonitorExitBasicBlock(
			MonitorExitBasicBlock monitorExitBasicBlock);
	public void visitLoopBasicBlock(LoopBasicBlock loopBasicBlock);
	public void visitIfBasicBlock(IfBasicBlock ifBasicBlock);
	public void visitSwitchBasicBlock(SwitchBasicBlock switchBasicBlock);
	public void visitSporadicInvokeBasicBlock(
			SporadicInvokeBasicBlock sporadicInvokeBasicBlock);
	
	// new methods for handling new objects -- from finalization (and memory analysis?)
	public void visitNewBasicBlock(NewBasicBlock newBasicBlock);
	
}
