package tetasarts.tir.basicblocks;


import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import tetasarts.tir.basicblocks.basicBlockTypes.LoopBasicBlock;

public class LoopBound {
	private int loopBound;
	private AbstractBasicBlock targetNode;
	private List<LoopBasicBlock> loopNodes;
	private List<AbstractBasicBlock> exitNodes;
	
	public int getLoopBound() {
		return loopBound;
	}
	
	public AbstractBasicBlock getTargetNode() {
		return targetNode;
	}

	public Iterator<LoopBasicBlock> getLoopNodeIterator() {
		return loopNodes.iterator();
	}
	
	public Iterator<AbstractBasicBlock> getExitNodeIterator() {
		return exitNodes.iterator();
	}
	
	public void addLoopNode(LoopBasicBlock loopNode) {
		loopNodes.add(loopNode);
	}

	public void addExitNode(AbstractBasicBlock exitNode) {
		exitNodes.add(exitNode);
	}
	
	public LoopBound(AbstractBasicBlock targetNode, int loopBound) {
		loopNodes = new LinkedList<LoopBasicBlock>();
		exitNodes = new LinkedList<AbstractBasicBlock>();
		this.targetNode = targetNode;
		this.loopBound = loopBound;
	}
}
