package tetasarts.tir.basicblocks.basicBlockTypes;

import java.util.HashSet;
import java.util.Set;
import java.util.logging.Logger;

import sun.security.action.PutAllAction;
import tetasarts.tir.basicblocks.AbstractBasicBlock;
import tetasarts.tir.basicblocks.IBasicBlockVistitor;
import tetasarts.tir.methods.MethodInformation;
import tetasarts.uppaal.translation.analysis.CallSite;
import tetasarts.uppaal.translation.analysis.Callee;


public class MethodCallingBasicBlock extends AbstractBasicBlock{
	private Set<MethodInformation> callees;
	private Callee unresolvedCallee = null;
	private CallSite callsite;
	
	
	private Logger logger = Logger.getLogger("generator");
	protected boolean specialInvoke = false;
	protected boolean interfaceInvoke = false;

	public MethodCallingBasicBlock(CallSite callsite) {
		this.callees = new HashSet<MethodInformation>();
		this.callsite = callsite;
	}
	
	public MethodCallingBasicBlock(CallSite callsite, Set<MethodInformation> callees) {
		this.callsite = callsite;
		this.callees = callees;
	}
	
	public MethodCallingBasicBlock(CallSite callsite, MethodInformation callee) {
		this.callsite = callsite;
		
		this.callees = new HashSet<MethodInformation>();
		this.callees.add(callee);
	}
	
	public MethodCallingBasicBlock(CallSite callsite, Callee unresolvedCallee) {
		this.callsite = callsite;
		this.unresolvedCallee = unresolvedCallee;
		this.callees = new HashSet<MethodInformation>();
	} 
	
	public boolean hasUnresolvedCallee() {
		return (this.unresolvedCallee != null);
	}
	
	public Callee getUnresolvedCallee() {
		return this.unresolvedCallee;
	}
	
	public CallSite getCallSite() {
		return this.callsite;
	}

	public boolean isPossibleCalleesSet() {
		return !this.callees.isEmpty();
	}
	
	public void setPossibleCallees(Set<MethodInformation> callees) {
		this.callees = callees;
	}	
	
	public void setPossibleCallees(MethodInformation callee) {
		this.callees = new HashSet<MethodInformation>();
		this.callees.add(callee);
	}	
	
	@Override
	public void accept(IBasicBlockVistitor v) {
		v.visitMethodCallingBasicBlock(this);
	}

	public boolean isSpecialInvoke() {
		return this.specialInvoke;
	}
	
	public Set<MethodInformation> getPossibleCallees() {
		return this.callees;
	}
	
	//TODO Consider moving this to classgraph
/*	public Set<MethodInformation> findConcreteMethods(ClassGraph classGraph) {
		Set<MethodInformation> result = new HashSet<MethodInformation>();
		
		if(calledClassName.contains("MeasurementHistory")) {
			System.out.println("hello");
		}
		
		AbstractClassNode current = classGraph.getClassFromCanonicalName(calledClassName);
		assert current != null : "Current is null?";
		
		MethodInformation methodInformation = current.getMethod(calledMethodName, calledMethodSignature);
		
		// find first concrete implementation
		while(methodInformation == null) {
			List<AbstractClassNode> list = classGraph.getPreds(current);
			if(list.size() == 0) {
				logger.info("No parent implementation for method: " + calledClassName + "." + calledMethodName + calledMethodSignature);
				break;
			}
			assert list.size() == 1 : "Class contains more than one predecessor! (multiple inheritance?)";
			current = list.get(0);
			methodInformation = current.getMethod(calledMethodName, calledMethodSignature);
		}
		if(methodInformation != null) {
			result.add(methodInformation);
		}
		
		// forward searching -- find overrides (if not special invoked)
		if (!specialInvoke) 
			findOverriddenMethods(classGraph, current, result);
		
		if(result.size() == 0) {
			logger.info("Could not find implementation for method: " + calledClassName + "." + calledMethodName + calledMethodSignature);
		}
		return result;
	}
	
	private void findOverriddenMethods(ClassGraph classGraph, AbstractClassNode classNode, Set<MethodInformation> result) {
		
		for(AbstractClassNode currentClass : classGraph.getSuccs(classNode)) {
			MethodInformation currentMethodImplementation = currentClass.getMethod(calledMethodName, calledMethodSignature);
			if(currentMethodImplementation != null) {
				result.add(currentMethodImplementation);
			}
			findOverriddenMethods(classGraph, currentClass, result);
		}
	}
	*/
}
