package tetasarts.tir.basicblocks.basicBlockTypes;

import org.apache.bcel.generic.InstructionHandle;

import tetasarts.exceptions.IncompatibleMergeException;
import tetasarts.tir.Node;
import tetasarts.tir.basicblocks.AbstractBasicBlock;
import tetasarts.tir.basicblocks.IBasicBlockVistitor;

public class SimpleBasicBlock extends AbstractBasicBlock{
	String sillyName;
	public SimpleBasicBlock(String sillyName) {
		this.sillyName = sillyName;
	}
	public SimpleBasicBlock() {
		this.sillyName = "unnamed";
	}
	
	@Override
	public void accept(IBasicBlockVistitor v) {
		v.visitSimpleBasicBlock(this);
	}
	@Override
	public boolean canMerge(Node<IBasicBlockVistitor> other) {
		
		return this.getClass().equals(other.getClass()) && !isTarget() && !((SimpleBasicBlock)other).isTarget();
	}
	
	@Override
	public String toString() {
		return sillyName;
	}
	
	@Override
	public AbstractBasicBlock merge(
			Node<IBasicBlockVistitor> other) throws IncompatibleMergeException {
		if(canMerge(other)){
			AbstractBasicBlock otherBlock = (AbstractBasicBlock)other;
			SimpleBasicBlock result =new SimpleBasicBlock(this.toString() + other.toString());
			for(InstructionHandle i : this.getBytecodes()){
				result.addBytecode(i);
			}
			for(InstructionHandle i : otherBlock.getBytecodes()){
				result.addBytecode(i);
			}
			result.setWCET(otherBlock.getWCET() + this.getWCET());
			
			return result;
		}
		else throw new IncompatibleMergeException(this.getClass().getSimpleName() +" Cannot merge " + other.getClass().getSimpleName()); 
	}
}
