package tetasarts.tir.graphtest;


import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import tetasarts.tir.Graph;


public class InformationGraph extends Graph<BasicInformation, IInformationVisitor>{
	private class HeadsFinderVisitor extends AbstractInformationVisitor{
		private List<BasicInformation> heads;
		public void defaultVisit(BasicInformation s) {
			if(getPreds(s).size() == 0){
				heads.add(s);
			}
		}
		public List<BasicInformation> getHeads(){
			heads = new ArrayList<BasicInformation>();
			for(BasicInformation block : getNodes()){
				block.accept(this);
			}
			return Collections.unmodifiableList(heads);
		}
	}
	
	private class TailsFinderVisitor extends AbstractInformationVisitor{
		private List<BasicInformation> tails;
		public void defaultVisit(BasicInformation s) {
			if(getSuccs(s).size() == 0){
				tails.add(s);
			}
		}
		public List<BasicInformation> getTails(){
			tails = new ArrayList<BasicInformation>();
			for(BasicInformation block : getNodes()){
				block.accept(this);
			}
			return Collections.unmodifiableList(tails);
		}
	}

	public List<BasicInformation> getHeads(){
		return new HeadsFinderVisitor().getHeads();
	}
	
	public List<BasicInformation> getTails(){
		return new TailsFinderVisitor().getTails();
	}

}