package tetasarts.tir.methods;

import tetasarts.tir.basicblocks.BasicBlockGraph;
import tetasarts.tir.sets.MethodSet;
import tetasarts.uppaal.UppaalTemplate;

public class MethodInformation {
	private String name;
	private String signature;
	public BasicBlockGraph instructionGraph;
	private int bytecodeSize;
	private boolean isSynchronized;
	private String canonicalClassName;
	private boolean used = false;
	private boolean generated = true;
	public boolean isGenerated() {
		return generated;
	}
	protected void setGenerated(boolean generated){
		this.generated = generated;
	}

	// name + signature must be pr. class unique
	public MethodInformation(String canonicalClassName, String name, String signature, int bytecodeSize) {
		this.canonicalClassName = canonicalClassName;
		this.name = name;
		this.signature = signature;
		this.instructionGraph = new BasicBlockGraph(getCanonicalName());
		this.bytecodeSize = bytecodeSize;
		MethodSet.globalSet.add(this);
	}

//	private UppaalTemplate templateRef = null;
//	public UppaalTemplate getTemplate(){
//		return templateRef;
//	}
//	public void setTemplate(UppaalTemplate template){
//		this.templateRef=template;
//	}
	
	public void setSynchronized(boolean isSynchronized) {
		this.isSynchronized = isSynchronized;
	}
	
	public boolean isSynchronized() {
		return isSynchronized;
	}
	
	public int getBytecodeSize() {
		return bytecodeSize;
	}
	
	public String getName(){
		return name;
	}
	
	public String getSignature(){
		return signature; 
	}
	
	public BasicBlockGraph getInstructionGraph(){
		// Normalize?
		return instructionGraph;
	}

	public String getCanonicalClassName() {
		return canonicalClassName;
	}
	
	public String getCanonicalName(){
		return canonicalClassName + "." + name + signature;
	}

	public boolean isUsed() {
		return used;
	}

	public void setUsed(boolean used) {
		this.used = used;
	}
	
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return this.getCanonicalName();
	}
}
