package tetasarts.tir.sets;

import java.util.HashSet;
import java.util.Iterator;

import tetasarts.tir.methods.MethodInformation;

public class MethodSet extends HashSet<MethodInformation>{
	/**
	 * 
	 */
	private static final long serialVersionUID = 5361322544140497963L;
	public static MethodSet globalSet = new MethodSet(); 
	
	/**
	 * Get method where name matches regex
	 * @see {@link http://java.sun.com/j2se/1.4.2/docs/api/java/lang/String.html#matches(java.lang.String)}
	 * @param regex
	 * @return
	 */
	public MethodSet getMapFromName(String regex){
		MethodSet resultSet = new MethodSet();
		Iterator<MethodInformation> methodIterator = this.iterator();
		while(methodIterator.hasNext()){
			MethodInformation method = methodIterator.next();
			if(method.getName().matches(regex)){
				resultSet.add(method);
			}
		}
		return resultSet;
	}
	public MethodSet getMapFromSignature(String regex){
		MethodSet resultSet = new MethodSet();
		Iterator<MethodInformation> methodIterator = this.iterator();
		while(methodIterator.hasNext()){
			MethodInformation method = methodIterator.next();
			if(method.getSignature().matches(regex)){
				resultSet.add(method);
			}
		}
		return resultSet;
	}
}
