package tetasarts.tir.sets;

import java.util.HashSet;
import java.util.Iterator;

import tetasarts.uppaal.UppaalTemplate;

public class TemplateSet extends HashSet<UppaalTemplate>{
	
	public static TemplateSet globalSet = new TemplateSet();
	/**
	 * 
	 */
	private static final long serialVersionUID = -5187591534537265980L;
	/**
	 * Get method where name matches regex
	 * @see {@link http://java.sun.com/j2se/1.4.2/docs/api/java/lang/String.html#matches(java.lang.String)}
	 * @param regex
	 * @return
	 */
	public TemplateSet getMapFromMethodName(String regex){
		TemplateSet resultSet = new TemplateSet();
		Iterator<UppaalTemplate> templateIterator = this.iterator();
		while(templateIterator.hasNext()){
			UppaalTemplate template = templateIterator.next();
			if(template.getMethodInformation().getName().matches(regex)){
				resultSet.add(template);
			}
		}
		return resultSet;
	}
	public TemplateSet getMapFromMethodSignature(String regex){
		TemplateSet resultSet = new TemplateSet();
		Iterator<UppaalTemplate> methodIterator = this.iterator();
		while(methodIterator.hasNext()){
			UppaalTemplate template = methodIterator.next();
			if(template.getMethodInformation().getSignature().matches(regex)){
				resultSet.add(template);
			}
		}
		return resultSet;
	}
}
