package tetasarts.uppaal;

import org.jdom.*;

/**
 * Represents a name element
 */
public class Name {
	@Override
	public String toString() {
		return name;
	}



	private String name;
	private int posX;
	private int posY;
	
	/**
	 * Creates a new name element with position 0,0.
	 * @param name The name of the Name element
	 */
	public Name(String name){
		this(name, 0, 0);
	}
	
	/**
	 * Creates a new name element
	 * @param name The name of the Name element	
	 * @param x The x position of the name location
	 * @param y The y position of the name location
	 */
	public Name(String name, int x, int y){
		this.name = name;
		this.posX = x;
		this.posY = y;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getPosX() {
		return posX;
	}

	public void setPosX(int posX) {
		this.posX = posX;
	}

	public int getPosY() {
		return posY;
	}

	public void setPosY(int posY) {
		this.posY = posY;
	}
	

	
	/**
	 * Creates an XML Element object corresponding to the Name object
	 * @return XML Element
	 */
	Element generateXMLElement(){
		Element result = new Element(this.getClass().getSimpleName().toLowerCase());
		
		result.addContent(this.name);
		result.setAttribute("x", Integer.toString(this.posX));
		result.setAttribute("y", Integer.toString(this.posY));
		
		return result;
	}
}
