package tetasarts.uppaal;


import java.util.ArrayList;

import tetasarts.tir.methods.MethodInformation;
import tetasarts.uppaal.declarations.Declarations;

public class Test {

	public static void main(String[] args) {
		UppaalModel nta = new UppaalModel(new Declarations(), new ArrayList<UppaalTemplate>(),
				"system thingie");
		UppaalTemplate template = new UppaalTemplate(new MethodInformation("canonicalName", "name", "signature", 8),
				"parameter", new Declarations(),
				new ArrayList<Location>(), null, new ArrayList<Transition>());
		nta.addTemplate(template);
		
		Location start = new Location("start", Location.LocationType.URGENT, 15, 15);
		start.setInvariant("label of location start", 25, 25);

		Location stop = new Location("stop",
				Location.LocationType.COMMITED, 175,
				15);
		stop.setComment("comment");

		Transition transition = new Transition(start.getId(), stop.getId());
		transition.setGuard("guard", 55, 60);
		//transition.setSync("sync", 3, 1);
		transition.setUpdate("update", 3, 3);
		transition.setSelect("select", 3, 2);
		transition.addNail(new Nail(55, 55));
		transition.addNail(new Nail(75, 55));

		template.addLocation(start);
		template.addLocation(stop);
		template.addTransition(transition);
		template.setInit(start);
		
		Location loc = new Location("test", Location.LocationType.NORMAL, -140,-100);
		Transition trans2 = new Transition(1, 3);
		trans2.setGuard("guard", 55, 60);
		//trans2.setSync("sync", 3, 1);
		trans2.setUpdate("update", 3, 3);
		trans2.setSelect("select", 3, 2);
		trans2.addNail(new Nail(0,-100));
		trans2.addNail(new Nail(-100,-150));
		template.addLocation(loc);
		template.addTransition(trans2);
		
		String outputFile = "output.xml";

		nta.writeModelToFile(outputFile);

		UppaalModel.correctXML(outputFile);
	}
}
