package tetasarts.uppaal.declarations;

import java.util.*;

public class Declarations {
	//clocks
	ArrayList<Clock> clocks;
	//channels
	ArrayList<Channel> channels;
	//int
	ArrayList<Int> integers;
	//bool
	ArrayList<Bool> booleans;
	//typedef
	StringBuilder additionalDeclarations;
	
	public Declarations(){
		clocks = new ArrayList<Clock>();
		channels = new ArrayList<Channel>();
		integers = new ArrayList<Int>();
		booleans = new ArrayList<Bool>();
		additionalDeclarations = new StringBuilder();
	}

	public ArrayList<Clock> getClocks() {
		return clocks;
	}

	public void setClocks(ArrayList<Clock> clocks) {
		this.clocks = clocks;
	}

	public ArrayList<Channel> getChannels() {
		return channels;
	}

	public void setChannels(ArrayList<Channel> channels) {
		this.channels = channels;
	}

	public ArrayList<Int> getIntegers() {
		return integers;
	}

	public void setIntegers(ArrayList<Int> integers) {
		this.integers = integers;
	}

	public ArrayList<Bool> getBooleans() {
		return booleans;
	}

	public void setBooleans(ArrayList<Bool> booleans) {
		this.booleans = booleans;
	}
	
	public void addClock(Clock clock){
		clocks.add(clock);
	}
	
	public void addChannel(Channel channel){
		channels.add(channel);
	}
	
	public void addInteger(Int integer){
		integers.add(integer);
	}
	
	public void addBoolean(Bool bool){
		booleans.add(bool);
	}
	
	public void addString(String declaration){
		additionalDeclarations.append(declaration).append("\n");
	}
	
	@Override
	public String toString(){
		StringBuilder stringBuilder = new StringBuilder();
		stringBuilder.append("//\n");
		Collections.sort(channels);
		for (Channel channel : channels) {
			stringBuilder.append(channel.toString()).append("\n");
		}
		for (Clock clock : clocks) {
			stringBuilder.append(clock.toString()).append("\n");
		}
		for (Int integer : integers) {
			stringBuilder.append(integer.toString()).append("\n");
		}
		for (Bool bool : booleans) {
			stringBuilder.append(bool.toString()).append("\n");
		}
		stringBuilder.append("\n");
		stringBuilder.append(additionalDeclarations.toString());
		stringBuilder.append("\n");
		return stringBuilder.toString();
	}
}
