package tetasarts.uppaal.modelcombiner.optimization;

import java.util.LinkedList;
import java.util.List;

import uppaal.NTA;

public class NTATetaSARTSOptimizer {

	private final NTA ntaSystem;
	private final List<TetaSARTSOptimization> optimizations;
	
	
	public NTATetaSARTSOptimizer(NTA ntaSystem, final TetaSARTSOptimization optimization) {
		this(ntaSystem, new LinkedList<TetaSARTSOptimization>() {
			private static final long serialVersionUID = 1L;

		{add(optimization);}});
	}
	
	public NTATetaSARTSOptimizer(NTA ntaSystem, List<TetaSARTSOptimization> optimizations) {
		this.ntaSystem = ntaSystem;
		this.optimizations = optimizations;
	}
	
	public void optimize() {
		for(TetaSARTSOptimization optimization : this.optimizations) {
			optimization.conductOptimization(ntaSystem);
		}
	}
}
