package tetasarts.uppaal.modelcombiner.optimization.sync;

import java.util.LinkedList;

import uppaal.Automaton;

public class AutomatonNode {

	private Automaton aut;
	private LinkedList<DependencyEdge> incomingEdges;
	private LinkedList<DependencyEdge> outgoingEdges;
	private int copyCount;
	
	public AutomatonNode(Automaton aut) {
		this.aut = aut;
		this.incomingEdges = new LinkedList<DependencyEdge>();
		this.outgoingEdges = new LinkedList<DependencyEdge>();
		this.copyCount = 0;
	}
	
	public Automaton getAutomaton() {
		return this.aut;
	}
	
	public LinkedList<DependencyEdge> getIncomingEdges() {
		return this.incomingEdges;
	}
	
	public LinkedList<DependencyEdge> getoutgoingEdges() {
		return this.outgoingEdges;
	}
	
	public void addIncomingEdge(DependencyEdge incomingEdge) {
		this.incomingEdges.add(incomingEdge);
	}
	
	public void addOutgoingEdge(DependencyEdge outgoingEdge) {
		this.outgoingEdges.add(outgoingEdge);
	}
	
	public int getCopycount() {
		return this.copyCount;
	}
	
	public void setCopycount(int copyCount) {
		this.copyCount = copyCount;
	}
	public void incCopycount() {
		this.copyCount++;
	}
	
}
