package tetasarts.uppaal.translation.analysis;

import java.util.HashMap;

import soot.jimple.spark.SparkTransformer;
import soot.options.Options;
import tetasarts.tir.classinfo.ClassGraph;

public class VTASootDevirtualizationAnalysis extends SootDevirtualizationAnalysis {
	private HashMap<String, String> sparkOptions;
	
	public VTASootDevirtualizationAnalysis(String mainClass, String mainMethod,
			ClassGraph classGraph) {
		super(mainClass, mainMethod, classGraph);
	}

	@Override
	protected void setSootOptions() {
		Options.v().set_whole_program(true);
		Options.v().set_keep_offset(true);
		this.sparkOptions = new HashMap<String, String>();
		
		sparkOptions.put("enabled","true");
		sparkOptions.put("verbose","false");
		sparkOptions.put("ignore-types","false");          
		sparkOptions.put("force-gc","false");            
		sparkOptions.put("pre-jimplify","false");          
		sparkOptions.put("vta","true");                   
		sparkOptions.put("rta","false");                   
		sparkOptions.put("field-based","false");           
		sparkOptions.put("types-for-sites","false");        
		sparkOptions.put("merge-stringbuffer","true");   
		sparkOptions.put("string-constants","false");     
		sparkOptions.put("simulate-natives","true");      
		sparkOptions.put("simple-edges-bidirectional","false");
		sparkOptions.put("on-fly-cg","true");            
		sparkOptions.put("simplify-offline","false");    
		sparkOptions.put("simplify-sccs","false");        
		sparkOptions.put("ignore-types-for-sccs","false");
		sparkOptions.put("propagator","worklist");
		sparkOptions.put("set-impl","double");
		sparkOptions.put("double-set-old","hybrid");         
		sparkOptions.put("double-set-new","hybrid");
		sparkOptions.put("dump-html","false");           
		sparkOptions.put("dump-pag","false");             
		sparkOptions.put("dump-solution","false");        
		sparkOptions.put("topo-sort","false");           
		sparkOptions.put("dump-types","true");             
		sparkOptions.put("class-method-var","true");     
		sparkOptions.put("dump-answer","false");          
		sparkOptions.put("add-tags","false");             
		sparkOptions.put("set-mass","false");
		
		
	}

	@Override
	protected void initDevirtualizationAnalysis() {
		SparkTransformer.v().transform("",sparkOptions);
	}

}
