package tetasarts.uppaal.translation.tasks;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.logging.Logger;

import javax.annotation.processing.AbstractProcessor;
import javax.annotation.processing.ProcessingEnvironment;
import javax.annotation.processing.RoundEnvironment;
import javax.annotation.processing.SupportedAnnotationTypes;
import javax.annotation.processing.SupportedSourceVersion;
import javax.lang.model.SourceVersion;
import javax.lang.model.element.Element;
import javax.lang.model.element.TypeElement;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import javax.tools.JavaCompiler.CompilationTask;

import tetasarts.Options;
import tetasarts.generator.Constants;
import tetasarts.tir.classinfo.AbstractClassNode;
import tetasarts.tir.classinfo.ClassGraph;
import tetasarts.tir.classinfo.PeriodicTask;
import tetasarts.tir.classinfo.SporadicTask;

import com.sun.source.tree.ClassTree;
import com.sun.source.tree.ExpressionTree;
import com.sun.source.tree.LiteralTree;
import com.sun.source.tree.MethodInvocationTree;
import com.sun.source.tree.MethodTree;
import com.sun.source.tree.NewClassTree;
import com.sun.source.tree.Tree.Kind;
import com.sun.source.util.TreePath;
import com.sun.source.util.TreePathScanner;
import com.sun.source.util.Trees;



public class TaskInfoFinder{
	CodeAnalyzerTreeVisitor visitor;
//	private Set<AbstractClassNode> taskList;
	private Set<PeriodicTask> periodicTasks;
	private Set<SporadicTask> sporadicTasks;
//	private ClassGraph classGraph;
//	private AbstractClassNode mainClass;
	public TaskInfoFinder(ClassGraph classGraph, AbstractClassNode mainClass) {
//		this.classGraph = classGraph;
//		this.mainClass = mainClass;

//		taskList = new HashSet<AbstractClassNode>();
		periodicTasks = new HashSet<PeriodicTask>();
		sporadicTasks = new HashSet<SporadicTask>();
		
//		if(!(s.getMethodName().equals("<init>") && s.getCorrespondingClass().getCanonicalName().equals("test.FooPeriodicThread"))) {
//			System.out.println("skipping! " + s.getCorrespondingClass().getCanonicalName() + "." + s.getMethodName() + s.getMethodSignature());
//			return;
//		}
//		System.out.println("parsing: " + s.getCorrespondingClass().getCanonicalName() + "." + s.getMethodName() + s.getMethodSignature());
		
		JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
		
		StandardJavaFileManager fileManager = compiler.getStandardFileManager(null, null, null);
		List<File> fileList = new LinkedList<File>();

		//Adds the CurrentTimeUpdater periodic thread to the system.
		
		//fileList.add(new File("src" + File.separator + "javax" + File.separator + "scj" + File.separator + "RealtimeSystem.java"));
		try {
			//TODO MUST BE FIXED!!
			//fileList.add(new File("src\\" + javaClass.getPackageName().replace('.', '\\') + "\\" + javaClass.getSourceFileName()));
			fileList.add(new File(Options.classpath.getClassFile(mainClass.getCanonicalName()).getPath().replace(File.separator + "bin" + File.separator, File.separator + "src" + File.separator).replace(".class", ".java")));
			if (Constants.USE_TIME_PERIODIC_THREAD)
				fileList.add(new File(Options.classpath.getClassFile(Constants.REALTIME_SYSTEM).getPath().replace(File.separator + "bin" + File.separator, File.separator + "src" + File.separator).replace(".class", ".java")));
		} catch (IOException e) {
			System.err.println("error loading " + Constants.REALTIME_SYSTEM);
			e.printStackTrace();
		}
//		System.out.println("Filename: " + "src\\" + javaClass.getPackageName().replace('.', '\\') + "\\" + javaClass.getSourceFileName());
		Iterable<? extends JavaFileObject> compilationUnits = fileManager.getJavaFileObjectsFromFiles(fileList);

		CompilationTask task = compiler.getTask(null, fileManager, null, Arrays.asList(new String[]{"-classpath", Options.classpath.toString()}), null, compilationUnits);
		
//		for(JavaFileObject a : compilationUnits) {
//			System.out.println("a: " + a.getKind());
////			TaskEvent f = new TaskEvent(TaskEvent.Kind.ANALYZE, a);
////			f.getCompilationUnit().accept(new CodeAnalyzerTreeVisitor(classGraph, mainClass), null);
//		}
		
		LinkedList<AbstractProcessor> processors = new LinkedList<AbstractProcessor>();
		processors.add(new CodeAnalyzerProcessor(classGraph, periodicTasks, sporadicTasks));
		task.setProcessors(processors);

		task.call();

//		if(s.getMethodName().equals("<init>")) {
//			
//			// inherits from ...
//			if (s.getCorrespondingClass().getCanonicalName().equals(Constants.PERIODIC_THREAD)) {
//				System.out.println("Periodic constructor found!");
//				//periodic
//			} else if (s.getCorrespondingClass().getCanonicalName().equals(Constants.SPORADIC_THREAD)) {
//				System.out.println("Sporadic constructor found!");
//				//sporadic
//			}
//		}
		
	}

	public Set<PeriodicTask> getPeriodicTasks() {
		return periodicTasks;
	}

	public Set<SporadicTask> getSporadicTasks() {
		return sporadicTasks;
	}
}

class CodeAnalyzerTreeVisitor extends TreePathScanner<Object, Trees>  {
	private ClassGraph classGraph;
	private Logger logger = Logger.getLogger("generator");
//	private AbstractClassNode resultClass;
	private PeriodicTask resultPeriodic;
	private SporadicTask resultSporadic;
	private Set<PeriodicTask> periodicList;
	private Set<SporadicTask> sporadicList;
	
	public CodeAnalyzerTreeVisitor(ClassGraph classGraph, Set<PeriodicTask> periodicList, Set<SporadicTask> sporadicList) {
		this.classGraph = classGraph;
		this.periodicList = periodicList;
		this.sporadicList = sporadicList;
	}
	
	@Override
	public Object visitNewClass(NewClassTree arg0, Trees arg1) {		
//		TreePath path = getCurrentPath();
//		while(path != null) {
//			System.out.println("path: " + path.getLeaf().getKind().toString());
//			path = path.getParentPath();
//		}
//		Element s = arg1.getElement(path);
//		Elements t = pe.getElementUtils();
//		
//		PackageElement g = t.getPackageOf(s);
//		System.out.println("package: " + g.getQualifiedName());
		
//		System.out.println("pos: " + arg1.getSourcePositions().getStartPosition(path.getCompilationUnit(), arg0));
//		System.out.println("line: " + path.getCompilationUnit().getLineMap().getLineNumber(arg1.getSourcePositions().getStartPosition(path.getCompilationUnit(), arg0)));
		
		
//		if(path == null) {
//			System.out.println("wtf s");
//		}
//		TypeMirror g = arg1.getTypeMirror(path);
//		
//		System.out.println("type: " + g);
//		TypeElement e = (TypeElement) arg1.getElement(path);
//		if(e!=null) {
//			System.out.println("element: " + e.getQualifiedName().toString());
//		} else {
//			System.out.println("element is null");
//		}
		//Set qualified class name into model
		
//		Element sdf = pe.getElementUtils().getPackageElement(Constants.SCJ_PACKAGE);
//		System.out.println("sdf: " + sdf.getKind());
		
		String className = arg0.getIdentifier().toString();
		
		//System.out.println("class: " + className);
		
//		System.out.println("visit new class: " + arg0.getIdentifier().toString());

		AbstractClassNode currentClass = findClass(className);

		if(currentClass == null) {
			return super.visitNewClass(arg0, arg1);
		}
		
//		System.out.println("current class: " + currentClass.getCanonicalName());
//		AbstractClassNode result = null;
		
		if(currentClass.inheritsFrom(Constants.PERIODIC_THREAD, classGraph) || currentClass.getCanonicalName().equals(Constants.PERIODIC_THREAD)) {
			if(resultPeriodic != null) {
//				System.out.println("resultClass not null! No parameters found!");
			}
//			System.out.println("periodic class: " + currentClass.getCanonicalName());
			resultPeriodic = new PeriodicTask(currentClass);
		} else if (currentClass.inheritsFrom(Constants.SPORADIC_THREAD, classGraph) || currentClass.getCanonicalName().equals(Constants.SPORADIC_THREAD)) {
			if(resultSporadic != null) {
//				System.out.println("resultClass not null! No parameters found!");
			}
//			System.out.println("sporadic class: " + currentClass.getCanonicalName());
			resultSporadic = new SporadicTask(currentClass);
		} else if (currentClass.getCanonicalName().equals(Constants.PERIODIC_PARAMETERS)) {
//			System.out.println("periodic parameter");
			if(resultPeriodic != null) {
				long period = 0;
				long deadline = 0;
				long offset = 0;

				List<? extends ExpressionTree> arguments = arg0.getArguments();

				try {
					if(arguments.size() > 3 || arguments.size() < 1) {
						throw new Exception ("argument size");
					}
					
					// period
					if(arguments.get(0).getKind().equals(Kind.NEW_CLASS)) {
						NewClassTree newClassTree = (NewClassTree)arguments.get(0);
						AbstractClassNode param = findClass(newClassTree.getIdentifier().toString());
//						System.out.println("period: " + param.getCanonicalName());
						//if(param == null || !param.inheritsFrom(Constants.RELATIVETIME, classGraph)) {
						if(param == null || (!param.getCanonicalName().equals(Constants.RELATIVETIME) && !param.inheritsFrom(Constants.RELATIVETIME, classGraph))) {	
							throw new Exception ("argument 1 is not RelativeTime");
						}
						period = getRelativeTime(((LiteralTree)newClassTree.getArguments().get(0)), param.getCanonicalName());
						
						
//						System.out.println("period: " + period);
					} else if(arguments.get(0).getKind().equals(Kind.INT_LITERAL)) {
						LiteralTree l = (LiteralTree)arguments.get(0);
						period = ((Integer)l.getValue()).longValue()*1000L;
					} else {
						throw new Exception ("argument 0");
					}
					// deadline
					if(arguments.size() > 1) {
						if(arguments.get(1).getKind().equals(Kind.NEW_CLASS)) {
							NewClassTree newClassTree = (NewClassTree)arguments.get(1);
							AbstractClassNode param = findClass(newClassTree.getIdentifier().toString());
//							System.out.println("deadline: " + param.getCanonicalName());
							//if(param == null || !param.inheritsFrom(Constants.RELATIVETIME, classGraph)) {
							if(param == null || (!param.getCanonicalName().equals(Constants.RELATIVETIME) && !param.inheritsFrom(Constants.RELATIVETIME, classGraph))) {
								throw new Exception ("argument 1 is not RelativeTime");
							}
							deadline = getRelativeTime(((LiteralTree)newClassTree.getArguments().get(0)), param.getCanonicalName());

//							System.out.println("deadline: " + deadline);
						} else if(arguments.get(1).getKind().equals(Kind.INT_LITERAL)) {
							LiteralTree l = (LiteralTree)arguments.get(1);
							deadline = ((Integer)l.getValue()).longValue()*1000L;
						} else {
							throw new Exception ("argument 1 is not RelativeTime");
						}
					} else {
						deadline = period;
					}

					// offset
					if(arguments.size() > 2) {
						if(arguments.get(2).getKind().equals(Kind.NEW_CLASS)) {
							NewClassTree newClassTree = (NewClassTree)arguments.get(2);
							AbstractClassNode param = findClass(newClassTree.getIdentifier().toString());
//							System.out.println("offset: " + param.getCanonicalName());
							if(param == null || !param.inheritsFrom(Constants.RELATIVETIME, classGraph)) {
								throw new Exception ("argument 2 is not RelativeTime");
							}
							offset = getRelativeTime(((LiteralTree)newClassTree.getArguments().get(0)), param.getCanonicalName());

//							System.out.println("offset: " + offset);
						} else if(arguments.get(2).getKind().equals(Kind.INT_LITERAL)) {
							LiteralTree l = (LiteralTree)arguments.get(2);
							offset = ((Integer)l.getValue()).longValue()*1000L;
						} else {
							throw new Exception ("argument 2 is not RelativeTime");
						}
					}
				
					
				} catch (Exception e) {
					logger.severe("Error parsing Periodic Parameters! " + e.getMessage());
					System.exit(-1);
				}
				
				resultPeriodic.setPeriod(period);
				resultPeriodic.setDeadline(deadline);
				resultPeriodic.setOffset(offset);
				
				periodicList.add(resultPeriodic);
				resultPeriodic = null;
			} else {
//				System.out.println("resultClass is null!");
			}
		} else if (currentClass.getCanonicalName().equals(Constants.SPORADIC_PARAMETERS)) {
//			System.out.println("sporadic parameter");
			if(resultSporadic != null) {
				int event = 0;
				long minInter = 0;
				long deadline = 0;
				List<? extends ExpressionTree> arguments = arg0.getArguments();
				
				try {
					if(arguments.size() > 3 || arguments.size() < 2) {
						throw new Exception ("argument size");
					}
					if(arguments.get(0).getKind().equals(Kind.INT_LITERAL)) {
						event = ((Integer)((LiteralTree)arguments.get(0)).getValue()).intValue();
//						System.out.println("event = " + event);
					} else {
						throw new Exception ("argument 0");
					}
					// minimum inter-arrival time
					if(arguments.get(1).getKind().equals(Kind.NEW_CLASS)) {
						NewClassTree newClassTree = (NewClassTree)arguments.get(1);
						AbstractClassNode param = findClass(newClassTree.getIdentifier().toString());
//						System.out.println("minimum inter-arrival time: " + param.getCanonicalName());
						if(param == null || !param.inheritsFrom(Constants.RELATIVETIME, classGraph)) {
							throw new Exception ("argument 1 is not RelativeTime");
						}
						minInter = getRelativeTime(((LiteralTree)newClassTree.getArguments().get(0)), param.getCanonicalName());
						
						
//						System.out.println("min inter: " + minInter);
					} else if(arguments.get(1).getKind().equals(Kind.INT_LITERAL)) {
						LiteralTree l = (LiteralTree)arguments.get(1);
						minInter = (((Integer)l.getValue()).longValue())*1000L;
					} else {
						throw new Exception ("argument 1");
					}
					// deadline
					if(arguments.size() == 3) {
						if(arguments.get(2).getKind().equals(Kind.NEW_CLASS)) {
							NewClassTree newClassTree = (NewClassTree)arguments.get(2);
							AbstractClassNode param = findClass(newClassTree.getIdentifier().toString());
//							System.out.println("deadline: " + param.getCanonicalName());
							if(param == null || !param.inheritsFrom(Constants.RELATIVETIME, classGraph)) {
								throw new Exception ("argument 1 is not RelativeTime");
							}
							deadline = getRelativeTime(((LiteralTree)newClassTree.getArguments().get(0)), param.getCanonicalName());

//							System.out.println("deadline: " + deadline);
						} else if(arguments.get(2).getKind().equals(Kind.INT_LITERAL)) {
							LiteralTree l = (LiteralTree)arguments.get(2);
							deadline = ((Integer)l.getValue()).longValue()*1000L;
						} else {
							throw new Exception ("argument 2 is not RelativeTime");
						}
					} else {
						deadline = minInter;
					}
				} catch (Exception e) {
					logger.severe("Error parsing Sporadic Parameters! " + e.getMessage());
					System.exit(-1);
				}

				resultSporadic.setEvent(event);
				resultSporadic.setMinInterarrival(minInter);
				resultSporadic.setDeadline(deadline);

				sporadicList.add(resultSporadic);
				resultSporadic = null;
			} else {
//				System.out.println("resultClass is null!");
			}
		}
		
//		findParameters(result, arg0);
		
//		boolean parameterFound = false;
//		
//		if(result != null) {
//			for (ExpressionTree currentArgument : arg0.getArguments()) {
//				
//				if(currentArgument.getKind().equals(Kind.NEW_CLASS)) {
//					NewClassTree current = (NewClassTree)currentArgument;
//					
//					System.out.println("f:enclosing " + current.getIdentifier());
//					if(current.getIdentifier().toString().endsWith("PeriodicParameters")) {
//						System.out.println("omgz!");
//						//f.getArguments().size()
//					} else if(current.getIdentifier().toString().endsWith("SporadicParameters")) {
//						
//					}
//				}
//			}
//		}
		return super.visitNewClass(arg0, arg1);
	}

	private long getRelativeTime(LiteralTree literalTree,
			String className) throws Exception {
		if(literalTree.getValue() instanceof Integer) {
			if(className.equals(Constants.RELATIVETIMESECONDS)) {
				return (((Integer)literalTree.getValue()).longValue()) * 1000000000;
			} else if(className.equals(Constants.RELATIVETIMEMILLI)) {
				return (((Integer)literalTree.getValue()).longValue()) * 1000000;
			} else if(className.equals(Constants.RELATIVETIMEMICRO)) {
				return (((Integer)literalTree.getValue()).longValue()) * 1000;
			} else if(className.equals(Constants.RELATIVETIMENANO)) {
				return ((Integer)literalTree.getValue()).longValue();
			} else if(className.equals(Constants.RELATIVETIME)) {
				return ((Integer)literalTree.getValue()).longValue();
			} else {
				throw new Exception("min inter-arrival error!");
			}
		} else if(literalTree.getValue() instanceof Long) {
			if(className.equals(Constants.RELATIVETIMESECONDS)) {
				return (((Long)literalTree.getValue()).longValue()) * 1000000000;
			} else if(className.equals(Constants.RELATIVETIMEMILLI)) {
				return (((Long)literalTree.getValue()).longValue()) * 1000000;
			} else if(className.equals(Constants.RELATIVETIMEMICRO)) {
				return (((Long)literalTree.getValue()).longValue()) * 1000;
			} else if(className.equals(Constants.RELATIVETIMENANO)) {
				return ((Long)literalTree.getValue()).longValue();
			} else if(className.equals(Constants.RELATIVETIME)) {
				return ((Integer)literalTree.getValue()).longValue();
			} else {
				throw new Exception("min inter-arrival error!");
			}
		} else {
			throw new Exception("error parsing RelativeTime!");
		}
	}

	private AbstractClassNode findClass(String className) {
		AbstractClassNode currentClass = classGraph.getClassFromCanonicalName(className);

		if(currentClass == null) {
			Set<AbstractClassNode> classes = classGraph.getClassesFromSimpleName(className);
//			Set<AbstractClassNode> classes = null;
			
			if(classes.size() > 1) {
				logger.severe("Ambiguous classname: " + className + ". Either rename class to unique name or use canonical name.");
				for (AbstractClassNode a : classes) {
					System.err.println("class: " + a.getCanonicalName());
				}
				System.exit(-1);
			} else if(classes.size() < 1) {
//				System.out.println("no class found!");
			} else {
				currentClass = (AbstractClassNode)classes.toArray()[0];
			}
		}
		return currentClass;
	}

	@Override
	public Object visitMethodInvocation(MethodInvocationTree arg0, Trees trees) {

//		if (arg0.getMethodSelect().toString().equals(Constants.REALTIME_SYSTEM_FIRE)){
//			if (arg0.getArguments().size() == 1){
//				if (arg0.getArguments().get(0).getKind().equals(Kind.INT_LITERAL)){
//					int event = ((Integer)((LiteralTree)arg0.getArguments().get(0)).getValue()).intValue();
//					System.out.println("ZOMG " + event);
//				}
//			}
//		}
		
//		TreePath path = getCurrentPath();
//		System.out.println("current: " + arg0.getKind());
//		System.out.println("zomg " + arg0 + " args: " + arg0.getArguments() + " methodSelect: "+ arg0.getMethodSelect() + 
//				" typeArgs: " + arg0.getTypeArguments());
//		System.out.println("parentpath: " + path.getParentPath().getLeaf().getKind());
//		System.out.println("path: " + path.getLeaf().equals(arg0));
//		SourcePositions pos = trees.getSourcePositions();
////		System.out.println("pos: " + pos.getStartPosition(path.getCompilationUnit(), path.getLeaf()));
////		System.out.println("start: " + pos.getStartPosition(arg0, arg0));
//
//		for(ExpressionTree fisk : arg0.getArguments()){
//			System.out.println("yep! " + fisk.getKind());
////			((IdentifierTree)fisk).getName();
////			IdentifierTree ff = ((IdentifierTree)fisk);
////			System.out.println("name is " + ff.getName());
//		}
//		Element e = (TypeElement)trees.getElement(path);
//		System.out.println("i'm here!");
//		if(e!=null)
//			System.out.println("zomg: " + e.getSimpleName());
		
		
		
		
		return super.visitMethodInvocation(arg0, trees);
	}
	
	@Override
	public Object visitClass(ClassTree classTree, Trees trees) {
		// ---- some code ----
//		System.out.println("visit class: " + classTree.getSimpleName());
//		TreePath path = getCurrentPath();
//		
//		TypeElement e = (TypeElement) trees.getElement(path);
//		if(e!=null) {
//			System.out.println(e.getQualifiedName().toString());
//		}
//		System.out.println("omg class " );
		return super.visitClass(classTree, trees);
	}
	@Override
	public Object visitMethod(MethodTree methodTree, Trees trees) {
		// ---- some code ----
//		System.out.println("visit method! " + methodTree.getName());
		return super.visitMethod(methodTree, trees);
	}
} 



@SupportedSourceVersion(SourceVersion.RELEASE_6)
@SupportedAnnotationTypes("*")
class CodeAnalyzerProcessor extends AbstractProcessor {
	
	private ClassGraph classGraph;
	private Set<PeriodicTask> periodicList;
	private Set<SporadicTask> sporadicList;
	
	public CodeAnalyzerProcessor(ClassGraph classGraph, Set<PeriodicTask> periodicList, Set<SporadicTask> sporadicList) {
		super();
		this.classGraph = classGraph;
		this.periodicList = periodicList;
		this.sporadicList = sporadicList;
	}

	private Trees trees;

	@Override
	public void init(ProcessingEnvironment pe) {
		super.init(pe);
		
		trees = Trees.instance(pe);
		
	}

	/**
	 * Processes the annotation types defined for this processor.
	 * 
	 * @param annotations
	 *			the annotation types requested to be processed
	 * @param roundEnvironment
	 *			environment to get information about the current and prior
	 *			round
	 * @return whether or not the set of annotations are claimed by this
	 *		 processor
	 */
	@Override
	public boolean process(Set<? extends TypeElement> annotations,
			RoundEnvironment roundEnvironment) {

		// Scanner class to scan through various component elements
		CodeAnalyzerTreeVisitor visitor = new CodeAnalyzerTreeVisitor(classGraph, periodicList, sporadicList);
//		Elements el = processingEnv.getElementUtils();
		
		for (Element e : roundEnvironment.getRootElements()) {
//			System.out.println("package: " + el.getPackageOf(e));;
//			System.out.println("E: " + e.getSimpleName());
//			e = e.getEnclosingElement();
			
//			for(Modifier f : e.getModifiers()) {
//				System.out.println(f.name());
//			}
			
//			for(Element i : e.getEnclosedElements()) {
//				System.out.println("encl: " + i.getSimpleName());
//			}
//			System.out.println("element: " + e.getSimpleName());
			TreePath tp = trees.getPath(e);
//			System.out.println("tp: " + tp.getLeaf().getKind());
			// invoke the scanner
//			System.out.println("scanning...");
			visitor.scan(tp, trees);
//			System.out.println("done scanning.");
//			TypeElement typeElement = (TypeElement) e;
//			System.out.println("rootelement: " + typeElement.getQualifiedName());
			
		}

		return false;
	}

}
