package javax.scj;

public abstract class PeriodicThread extends RealtimeThread {
	/**
	 * The period of the thread
	 */
	int period;
	/**
	 * The offset time of the thread
	 */
	int offset;

	/**
	 * Creates a new PeriodicThread with the specified periodic parameters
	 * @param pp The periodic parameters of the thread
	 */
	public PeriodicThread(PeriodicParameters pp) {
		this.period = pp.getPeriod();
		this.offset = pp.getOffset();
		this.deadline = pp.getDeadline();

		// insert in a deadline monotonic order
		int cnt = threadList.size();
		int pos;
		for (pos = 0; pos < cnt; ++pos) {
			RealtimeThread realtimeThread = (RealtimeThread)threadList.elementAt(pos);
			if (this.deadline < realtimeThread.deadline) {
				break;
			}
		}
		threadList.insertElementAt(this, pos);
	}
}
