package javax.scj;

import java.util.Vector;

public abstract class RealtimeThread {
	/**
	 * The deadline of the thread
	 */
	int deadline;
	
	static Vector threadList = new Vector();

	/**
	 * The logic for the event. run() gets invoked from the scheduler either
	 * periodic, or on a hardware event or on a software event (fire):
	 * 
	 * @return true if ready for termination
	 */
	abstract protected boolean run();

	/**
	 * Gets invoked in the shutdown phase at the same period as run (instead of
	 * run()). Invoked until return true.
	 * 
	 * @return true if shutdown is finished.
	 */
	protected boolean cleanup() {
		return true;
	}
}
