package javax.scj;

public abstract class SporadicThread extends RealtimeThread {
	/**
	 * The event which must be fired to invoke the sporadic thread.
	 */
	int event;
	/**
	 * The minimum interarrival time.
	 */
	int minInterarrival;

	/**
	 * Creates a new SporadicThread with the specified sporadic parameters
	 * @param sp The sporadic parameters of the thread
	 */
	public SporadicThread(SporadicParameters sp) {
		this.event = sp.getEvent();
		this.minInterarrival = sp.getMinInterarrival();
		this.deadline = sp.getDeadline();

		// insert in a deadline monotonic order
		int cnt = threadList.size();
		int pos;
		for (pos = 0; pos < cnt; ++pos) {
			RealtimeThread realtimeThread = (RealtimeThread)threadList.elementAt(pos);
			if (this.deadline < realtimeThread.deadline) {
				break;
			}
		}
		threadList.insertElementAt(this, pos);
	}

//	/**
//	 * Used to fire the sporadic thread.
//	 * Use RealtimeSystem.fire(int event) instead.
//	 */
//	public final void fire() {
//		RealtimeSystem.fire(this.event);
//	}
}
