package com.tetaj.ircfg;

import java.util.ArrayList;

public class LoopInfo {

	private static int globalId = 0;
	
	private int id;
	private int loopBound;
	private ArrayList<BasicBlock> basicBlocks;
	private ArrayList<Edge> backEdges;
	
	public LoopInfo() {
		this.id = ++LoopInfo.globalId;
		this.loopBound = -1;
		this.basicBlocks = new ArrayList<BasicBlock>();
		this.backEdges = new ArrayList<Edge>();
	}
	
	public int getId() {
		return this.id;
	}
	
	public void setLoopBound(int bound) {
		this.loopBound = bound;
	}
	
	public int getLoopBound() {
		return this.loopBound;
	}
	
	public void addBasicBlock(BasicBlock basicBlock) {
		if(!this.basicBlocks.contains(basicBlock))
			this.basicBlocks.add(basicBlock);
	}
	
	public ArrayList<BasicBlock> getBasicBlocks() {
		return this.basicBlocks;
	}
	
	public void addBackEdge(Edge edge) {
		this.backEdges.add(edge);
	}
	
	public ArrayList<Edge> getBackEdges() {
		return this.backEdges;
	}
	
}
