package com.tetaj.modelgenerator.annotationextractor.file;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import com.tetaj.prettyprinter.AppConfig;

public class FileFinder {
	private FileCache cache;
	
	public FileFinder() {
		this.cache = new FileCache();
	}
	
	public BufferedReader find(String sourceFilePath) throws IOException {
		BufferedReader reader = this.cache.get(sourceFilePath);
		
		if (reader == null) {
			File sourceFile = getFile(sourceFilePath);			
			
			FileReader fileReader = new FileReader(sourceFile.getPath());
			
			reader = new BufferedReader(fileReader);
			reader.mark((int) sourceFile.length());
			
			this.cache.set(sourceFilePath, fileReader, reader);
		}
		
		reader.reset();
		return reader;
	}
	
	private File getFile(String filePath) throws FileNotFoundException {
		ArrayList<String> sourcePaths = AppConfig.getSourcePaths();
		
		for (String sourcePath : sourcePaths) {
			File path = new File(new File(sourcePath), filePath);
			
			if(path.isFile())
				return path;
		}
		
		throw new FileNotFoundException();
	}
	
}
